
Redmine - Defect #14699

Cannot change "From" header in email notifications

2013-08-15 17:44 - Zach Hamman

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 2.6.1   

Resolution: Fixed Affected version:  

Description

In Redmine 1.x (Rails 2.3), using from method in custom mailer changed the From header from Setting.mail_from.

According to Rails 3 Action Mailer documentation, mail method can receive :from header.  Redmine 2.x's Mailer#mail does

header.merge!{'From'=>Setting.mail_from,...}.  This results in the from header being overridden and removes default functionality.

I have made a change to Mailer#mail to do header.reverse_merge! instead of header.merge!, but I am unsure if this is the best path. 

However, this did set up the email headers correctly.

Associated revisions

Revision 13784 - 2014-12-21 20:46 - Jean-Philippe Lang

Don't overwrite headers that were already set (#14699).

Revision 13798 - 2014-12-26 11:41 - Jean-Philippe Lang

Merged r13784 (#14699).

History

#1 - 2014-11-24 10:55 - Vincent Robert

- File merge_headers.diff added

Here is a patch where we use the headers.reverse_merge! method instead of headers.merge!

As we can pass headers as a parameter, I think we should use a reverse_merge in order to not override our hash with default values:

  def mail(headers={}, &block)

    headers.reverse_merge! 'X-Mailer' => 'Redmine',

            'X-Redmine-Host' => Setting.host_name,

            'X-Redmine-Site' => Setting.app_title,

            'X-Auto-Response-Suppress' => 'OOF',

            'Auto-Submitted' => 'auto-generated',

            'From' => Setting.mail_from,

            'List-Id' => "<#{Setting.mail_from.to_s.gsub('@', '.')}>" 

 This could be very useful in some of my plugins. Thanks

#2 - 2014-12-17 16:02 - Jean-Philippe Lang

- Target version set to 2.6.1

#3 - 2014-12-21 20:47 - Jean-Philippe Lang

- Category changed from Email notifications to Code cleanup/refactoring

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Fix committed in r13784, thanks.

#4 - 2014-12-26 11:41 - Jean-Philippe Lang
https://www.redmine.org/projects/redmine/repository/svn/revisions/13784


- Status changed from Resolved to Closed

Files

merge_headers.diff 488 Bytes 2014-11-24 Vincent Robert

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

